.\"	$NetBSD: dl.4,v 1.11 2003/07/26 20:17:37 salo Exp $
.\"
.\" Copyright (c) 1997 Ben Harris.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.Dd January 28, 1997
.Dt DL 4 vax
.Os
.Sh NAME
.Nm dl
.Nd
.Tn DL-11 Ns / Ns Tn DLV-11
serial device driver
.Sh SYNOPSIS
.Cd "dl0 at uba? csr 0176500"
.Cd "dl1 at uba? csr 0176510"
.Cd "dl2 at uba? csr 0176520"
.Cd "dl3 at uba? csr 0176530"
.Sh DESCRIPTION
The
.Nm
driver controls a
.Tn DL-11 Ns -compatible
asynchronous serial card, and probably things compatible with it.  A
four-port
.Tn DLV-11J
will appear four times in the device list, as the ports look like
separate cards to the driver.
.Pp
.Pp
The
.Nm
driver provides the normal interface described in
.Xr tty 4 ,
but many of the configuration calls are unsupported, since their
functions are handled by jumpers or switches on the serial card
itself.  Calls related to modem-control lines are also ignored, since
these cards lack them.
.Pp
There's a chance this driver might also work with an
.Tn LP11 ,
an
.Tn LPV11
or even a
.Tn PC11 ,
but it hasn't been tested.
.Sh FILES
.Bl -tag -width /dev/ttyJ? -compact
.It Pa /dev/ttyJ?
Special files for communicating with dl devices.
.El
.\" .Sh EXAMPLES
.Sh DIAGNOSTICS
.Bl -diag
.It dl%d: rx overrun.
The character in the receive buffer wasn't read before the next
character arrived, and has been lost.
.It dl%d: stray rx interrupt.
The driver was called to service a receive interrupt, but there was
nothing for it to read.
.El
.Sh SEE ALSO
.Xr tty 4
.\" .Sh STANDARDS
.Sh HISTORY
The
.Nm
driver was written for
.Nx 1.3 .
.Sh AUTHORS
Ben Harris \*[Lt]bjh21@NetBSD.org\*[Gt]
.Sh BUGS
The
.Tn DL-11
and friends only have single-character receive and transmit buffers,
so an interrupt is generated for every character received or
transmitted.  Attempting to receive data at even moderately high rates
will cause rx overruns.  Fast transmission seems to be fine though.
.Pp
There is no support in the driver for the paper-tape reader on an
.Tn LT33
attached via a
.Tn DLV-11KA
or similar.
.Pp
The overrun message is logged in the interrupt routine itself, which
will probably just make the problem worse.
.Pp
The CSR printed on startup is that of the receiver, while the
interrupt vector is that of the transmitter.
.Pp
In order to determine the card's interrupt vector, the driver sends a
.Dv NUL
to each port.  This may confuse things attached to them.
.Pp
The driver has so far only been tested on a
.Tn DLV-11J .
It may or may not work on the other cards it claims to support.
